import type { CheckboxProps } from '@fle-ui/next';
import type { CheckboxGroupProps } from '@fle-ui/next/lib/checkbox';
import React from 'react';
import type { ProFormFieldItemProps, ProFormFieldRemoteProps } from '../../interface';
export declare type ProFormCheckboxGroupProps = ProFormFieldItemProps<CheckboxGroupProps, HTMLInputElement> & {
    layout?: 'horizontal' | 'vertical';
    options?: CheckboxGroupProps['options'];
} & ProFormFieldRemoteProps;
declare const CheckboxGroup: React.FC<ProFormCheckboxGroupProps>;
export declare type ProFormCheckboxProps = ProFormFieldItemProps<CheckboxProps, HTMLInputElement>;
/**
 * 多选框的
 *
 * @param
 */
declare const ProFormCheckboxComponents: React.FC<ProFormCheckboxProps>;
declare const WrappedProFormCheckbox: typeof ProFormCheckboxComponents & {
    Group: typeof CheckboxGroup;
};
export default WrappedProFormCheckbox;
