var _excluded = ["steps", "columns", "forceUpdate", "grid"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { useLatest } from '@fle-ui/pro-utils';
import React, { useCallback, useMemo } from 'react';
import { StepsForm as ProStepsForm } from '../../../layouts/StepsForm';
import BetaSchemaForm from '../index';

var StepsForm = function StepsForm(_ref) {
  var steps = _ref.steps,
      columns = _ref.columns,
      forceUpdate = _ref.forceUpdate,
      grid = _ref.grid,
      props = _objectWithoutProperties(_ref, _excluded);

  var propsRef = useLatest(props);
  /**
   * Fixed StepsForm toggle step causing formRef to update
   */

  var onCurrentChange = useCallback(function (current) {
    var _propsRef$current$onC, _propsRef$current;

    (_propsRef$current$onC = (_propsRef$current = propsRef.current).onCurrentChange) === null || _propsRef$current$onC === void 0 ? void 0 : _propsRef$current$onC.call(_propsRef$current, current);
    forceUpdate([]);
  }, [forceUpdate, propsRef]);
  var StepDoms = useMemo(function () {
    return steps === null || steps === void 0 ? void 0 : steps.map(function (step, index) {
      return /*#__PURE__*/React.createElement(BetaSchemaForm, _extends({
        grid: grid
      }, step, {
        // eslint-disable-next-line react/no-array-index-key
        key: index,
        layoutType: "StepForm",
        columns: columns[index]
      }));
    });
  }, [columns, grid, steps]);
  return /*#__PURE__*/React.createElement(ProStepsForm, _extends({}, props, {
    onCurrentChange: onCurrentChange
  }), StepDoms);
};

export default StepsForm;