import type { InputProps } from '@fle-ui/next';
import type { InputRef, PasswordProps } from '@fle-ui/next/lib/input';
import React from 'react';
import type { ProFormFieldItemProps } from '../../interface';
/**
 * 文本组件
 *
 * @param
 */
declare const ProFormText: React.FC<ProFormFieldItemProps<InputProps, InputRef>>;
declare const Password: React.FC<ProFormFieldItemProps<PasswordProps, InputRef>>;
declare const WrappedProFormText: typeof ProFormText & {
    Password: typeof Password;
};
export default WrappedProFormText;
