import "@fle-ui/next/es/form/style";
import _Form from "@fle-ui/next/es/form";

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { BaseForm } from '../../BaseForm';
import { Group, ProFormItem } from '../../components';

function ProForm(props) {
  return /*#__PURE__*/React.createElement(BaseForm, _extends({
    layout: "vertical",
    submitter: {
      // 反转按钮，在正常模式下，按钮应该是主按钮在前
      render: function render(_, dom) {
        return dom.reverse();
      }
    },
    contentRender: function contentRender(items, submitter) {
      return /*#__PURE__*/React.createElement(React.Fragment, null, items, submitter);
    }
  }, props));
}

ProForm.Group = Group;
ProForm.useForm = _Form.useForm;
ProForm.Item = ProFormItem;
ProForm.useWatch = _Form.useWatch;
ProForm.ErrorList = _Form.ErrorList;
ProForm.Provider = _Form.Provider;
ProForm.useFormInstance = _Form.useFormInstance;
export { ProForm };