import type { ProFieldMoneyProps } from '@fle-ui/pro-field';
import type { InputNumberProps } from '@fle-ui/next';
import React from 'react';
import type { ProFormFieldItemProps } from '../../interface';
export declare type ProFormMoneyProps = ProFormFieldItemProps<Omit<ProFieldMoneyProps, 'valueType' | 'text'> & InputNumberProps> & {
    customSymbol?: string;
    locale?: string;
    min?: InputNumberProps['min'];
    max?: InputNumberProps['min'];
};
declare const _default: React.ForwardRefExoticComponent<{
    fieldProps?: (import("../../interface").FieldProps<any> & Omit<import("@fle-ui/pro-field").FieldMoneyProps, "text" | "valueType"> & InputNumberProps<import("rc-input-number/lib/utils/MiniDecimal").ValueType>) | undefined;
    placeholder?: string | string[] | undefined;
    secondary?: boolean | undefined;
    cacheForSwr?: boolean | undefined;
    disabled?: boolean | undefined;
    width?: number | "sm" | "md" | "xl" | "xs" | "lg" | undefined;
    proFieldProps?: import("@fle-ui/pro-utils").ProFieldProps | undefined;
    footerRender?: import("../../interface").LightFilterFooterRender | undefined;
    children?: React.ReactNode;
} & Omit<import("..").ProFormItemProps, "valueType"> & Pick<import("../../interface").ProFormGridConfig, "colProps"> & import("../../interface").ExtendsProps & {
    customSymbol?: string | undefined;
    locale?: string | undefined;
    min?: import("rc-input-number/lib/utils/MiniDecimal").ValueType | undefined;
    max?: import("rc-input-number/lib/utils/MiniDecimal").ValueType | undefined;
} & React.RefAttributes<any>>;
export default _default;
