"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.group = void 0;

var _react = _interopRequireDefault(require("react"));

var _layouts = require("../../../layouts");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var group = function group(item, _ref) {
  var genItems = _ref.genItems;

  if (item.valueType === 'group') {
    var _item$getFieldProps;

    if (!item.columns || !Array.isArray(item.columns)) return null;
    return /*#__PURE__*/_react.default.createElement(_layouts.ProFormGroup, _extends({
      key: item.key,
      label: item.label,
      colProps: item.colProps,
      rowProps: item.rowProps
    }, (_item$getFieldProps = item.getFieldProps) === null || _item$getFieldProps === void 0 ? void 0 : _item$getFieldProps.call(item)), genItems(item.columns));
  }

  return true;
};

exports.group = group;