import type { InputNumberProps } from '@fle-ui/next';
import React from 'react';
import type { ProFormFieldItemProps } from '../../interface';
export declare type Value = string | number | undefined;
export declare type ValuePair = Value[];
export declare type RangeInputNumberProps = Omit<InputNumberProps, 'value' | 'defaultValue' | 'onChange' | 'placeholder'> & {
    value?: ValuePair;
    defaultValue?: ValuePair | undefined;
    onChange?: (value?: ValuePair) => void;
};
export declare type ProFormDigitRangeProps = ProFormFieldItemProps<RangeInputNumberProps> & {
    separator?: string;
    separatorWidth?: number;
};
declare const _default: React.ForwardRefExoticComponent<{
    fieldProps?: (import("../../interface").FieldProps<any> & Omit<InputNumberProps<import("rc-input-number/lib/utils/MiniDecimal").ValueType>, "defaultValue" | "placeholder" | "onChange" | "value"> & {
        value?: ValuePair | undefined;
        defaultValue?: ValuePair | undefined;
        onChange?: ((value?: ValuePair | undefined) => void) | undefined;
    }) | undefined;
    placeholder?: string | string[] | undefined;
    secondary?: boolean | undefined;
    cacheForSwr?: boolean | undefined;
    disabled?: boolean | undefined;
    width?: number | "sm" | "md" | "xl" | "xs" | "lg" | undefined;
    proFieldProps?: import("@fle-ui/pro-utils").ProFieldProps | undefined;
    footerRender?: import("../../interface").LightFilterFooterRender | undefined;
    children?: React.ReactNode;
} & Omit<import("..").ProFormItemProps, "valueType"> & Pick<import("../../interface").ProFormGridConfig, "colProps"> & import("../../interface").ExtendsProps & {
    separator?: string | undefined;
    separatorWidth?: number | undefined;
} & React.RefAttributes<any>>;
export default _default;
