import type { InputNumberProps } from '@fle-ui/next';
import React from 'react';
import type { ProFormFieldItemProps } from '../../interface';
export declare type ProFormDigitProps = ProFormFieldItemProps<InputNumberProps> & {
    min?: InputNumberProps['min'];
    max?: InputNumberProps['max'];
};
declare const _default: React.ForwardRefExoticComponent<{
    fieldProps?: (import("../../interface").FieldProps<any> & InputNumberProps<import("rc-input-number/lib/utils/MiniDecimal").ValueType>) | undefined;
    placeholder?: string | string[] | undefined;
    secondary?: boolean | undefined;
    cacheForSwr?: boolean | undefined;
    disabled?: boolean | undefined;
    width?: number | "sm" | "md" | "xl" | "xs" | "lg" | undefined;
    proFieldProps?: import("@fle-ui/pro-utils").ProFieldProps | undefined;
    footerRender?: import("../../interface").LightFilterFooterRender | undefined;
    children?: React.ReactNode;
} & Omit<import("..").ProFormItemProps, "valueType"> & Pick<import("../../interface").ProFormGridConfig, "colProps"> & import("../../interface").ExtendsProps & {
    min?: import("rc-input-number/lib/utils/MiniDecimal").ValueType | undefined;
    max?: import("rc-input-number/lib/utils/MiniDecimal").ValueType | undefined;
} & React.RefAttributes<any>>;
export default _default;
