import type { FormProps } from '@fle-ui/next';
import React from 'react';
import type { CommonFormProps } from '../../BaseForm';
export declare type ProFormProps<T = Record<string, any>> = Omit<FormProps<T>, 'onFinish'> & CommonFormProps<T>;
declare function ProForm<T = Record<string, any>>(props: ProFormProps<T> & {
    children?: React.ReactNode | React.ReactNode[];
}): JSX.Element;
declare namespace ProForm {
    var Group: React.FC<import("../../interface").GroupProps>;
    var useForm: typeof import("@fle-ui/next/es/form/Form").useForm;
    var Item: React.FC<import("../../components").ProFormItemProps>;
    var useWatch: typeof import("rc-field-form/es/useWatch").default;
    var ErrorList: typeof import("@fle-ui/next/es/form/ErrorList").default;
    var Provider: React.FC<import("@fle-ui/next/es/form/context").FormProviderProps>;
    var useFormInstance: typeof import("@fle-ui/next/es/form/hooks/useFormInstance").default;
}
export { ProForm };
