"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ProForm = ProForm;

var _next = require("@fle-ui/next");

var _react = _interopRequireDefault(require("react"));

var _BaseForm = require("../../BaseForm");

var _components = require("../../components");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ProForm(props) {
  return /*#__PURE__*/_react.default.createElement(_BaseForm.BaseForm, _extends({
    layout: "vertical",
    submitter: {
      // 反转按钮，在正常模式下，按钮应该是主按钮在前
      render: function render(_, dom) {
        return dom.reverse();
      }
    },
    contentRender: function contentRender(items, submitter) {
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, items, submitter);
    }
  }, props));
}

ProForm.Group = _components.Group;
ProForm.useForm = _next.Form.useForm;
ProForm.Item = _components.ProFormItem;
ProForm.useWatch = _next.Form.useWatch;
ProForm.ErrorList = _next.Form.ErrorList;
ProForm.Provider = _next.Form.Provider;
ProForm.useFormInstance = _next.Form.useFormInstance;